/* (C) 2009-2010 Yana */

#define YK0A_PREPROCESS_ONLY
#include "yk0a_arm.h"

#include "config.h"

#define VECTOR_FROM vector
#define VECTOR_SIZE 0x40
#define VECTOR_TO 0

#define OFFSET(a) ((a) * 4)

	.global minix_stack
	.comm minix_stack, K_STACK_BYTES, YK0A_STACK_ALIGN

	.text
	.balign 4

vector:
	ldr pc, vector_0
	ldr pc, vector_1
	ldr pc, vector_2
	ldr pc, vector_3
	ldr pc, vector_4
	ldr pc, vector_5
	ldr pc, vector_6
	ldr pc, vector_7
vector_0:
	.word 0 /* reset */
vector_1:
	.word minix_exception_interrupt_procedure
vector_2:
	.word minix_exception_interrupt_procedure
vector_3:
	.word minix_exception_interrupt_procedure
vector_4:
	.word minix_exception_interrupt_procedure
vector_5:
	.word 0 /* reserve */
vector_6:
	.word minix_exception_interrupt_procedure
vector_7:
	.word 0 /* fiq */

	.global MINIX
MINIX:
	mov r4, r0

	ldr r0, =VECTOR_FROM
	ldr r1, =VECTOR_TO
	ldr r2, =(VECTOR_FROM + VECTOR_SIZE)
start_0:
	ldr r3, [r0], #4
	str r3, [r1], #4
	cmp r0, r2
	bne start_0

	mov r0, r4
	ldr sp, =(minix_stack + K_STACK_BYTES / YK0A_STACK_ALIGN * YK0A_STACK_ALIGN - MINIX_ARGUMENT)
	ldr lr, =minix_exception_interrupt_procedure_0
	b glue_initialize

minix_exception_interrupt_procedure:
	ldr sp, =proc_ptr
	ldr sp, [sp]
	add sp, sp, #OFFSET(0)
	stmia sp!, {r0-r12, sp, lr}^
	stmia sp!, {lr}
	mrs r0, spsr
	stmia sp!, {r0}
	ldr sp, =(minix_stack + K_STACK_BYTES / YK0A_STACK_ALIGN * YK0A_STACK_ALIGN - MINIX_ARGUMENT)
	bl glue_exception_interrupt_procedure

minix_exception_interrupt_procedure_0:
	ldr sp, =proc_ptr
	ldr sp, [sp]
	add sp, sp, #OFFSET(17)
	ldmdb sp!, {r0}
	msr spsr, r0
	ldmdb sp!, {lr}
	ldmdb sp!, {r0-r12, sp, lr}^
	movs pc, lr
