/* (C) 2009-2010 Yana */

#if !defined(YK0A_INTERNAL_H)
#define YK0A_INTERNAL_H

#include "yk0a_mips.h"

#define YK0A_CONTEXT_BASE 8
#if defined(YK0A_CUSTOM_ENABLE_PORT)
#define YK0A_CONTEXT_SIZE 35
#else
#define YK0A_CONTEXT_SIZE 34
#endif

#define YK0A_STATE_READY 0
#define YK0A_STATE_RECEIVE 1
#define YK0A_STATE_REPLY 2
#define YK0A_STATE_SEND 3

#if !defined(YK0A_PREPROCESS_ONLY)

__inline__ static yk0a_uint32_t yk0a_interrupt_read_mask(void) {
	return (yk0a_mips_read_status() & YK0A_MIPS_STATUS_IM_MASK) >> YK0A_MIPS_STATUS_IM_SHIFT;
}

__inline__ static yk0a_uint32_t yk0a_interrupt_read_request(void) {
	return (yk0a_mips_read_cause() & YK0A_MIPS_CAUSE_IP_MASK) >> YK0A_MIPS_CAUSE_IP_SHIFT;
}

__inline__ static void yk0a_interrupt_write_mask(yk0a_uint32_t mask) {
	yk0a_mips_write_status((yk0a_mips_read_status() & ~YK0A_MIPS_STATUS_IM_MASK) | ((mask << YK0A_MIPS_STATUS_IM_SHIFT) & YK0A_MIPS_STATUS_IM_MASK));
}

__inline__ static void yk0a_interrupt_write_request(yk0a_uint32_t request) {
	yk0a_mips_write_cause((yk0a_mips_read_cause() & ~YK0A_MIPS_CAUSE_IP_MASK) | ((request << YK0A_MIPS_CAUSE_IP_SHIFT) & YK0A_MIPS_CAUSE_IP_MASK));
}

__inline__ static void yk0a_interrupt_initialize(void) {
	yk0a_interrupt_write_mask(0);
}

#endif

#endif
